/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.52 by edhill, Wed Dec 1 16:59:42 2004 UTC revision 1.75 by jmc, Fri Feb 24 23:15:25 2006 UTC
# Line 27  usage() Line 27  usage()
27      echo "                             (DEF=\"make output.txt\")"      echo "                             (DEF=\"make output.txt\")"
28      echo "  (-m|-make) STRING        command to use for \"make\""      echo "  (-m|-make) STRING        command to use for \"make\""
29      echo "                             (DEF=\"make\")"      echo "                             (DEF=\"make\")"
30        echo "  (-odir) STRING           used to build output directory name"
31        echo "                             (DEF=\"hostname\")"
32      echo "  (-ptracers|-ptr) STRING  specify which ptracers to test"      echo "  (-ptracers|-ptr) STRING  specify which ptracers to test"
33      echo "                             (DEF=\"1 2 3 4 5\")"      echo "                             (DEF=\"1 2 3 4 5\")"
34      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"
# Line 95  testoutput_for_prop() Line 97  testoutput_for_prop()
97      fi      fi
98      if [ -r $1/$4/output.txt ]; then      if [ -r $1/$4/output.txt ]; then
99          grep "$2" $1/$4/output.txt | sed 's/.*=//' | cat -n > tmp1.txt          grep "$2" $1/$4/output.txt | sed 's/.*=//' | cat -n > tmp1.txt
100          lncnt=`wc -l tmp1.txt | awk '{print $1}' `          lncntA=`wc -l tmp1.txt | awk '{print $1}' `
101          if [ $lncnt -lt 3 ]; then          if [ $lncntA -lt 3 ]; then
102              if [ $verbose -gt 0 ]; then              if [ $verbose -gt 0 ]; then
103                  echo Not enough lines of output when searching for "$2" 1>&2                  echo Not enough lines of output when searching for "$2" 1>&2
104              fi              fi
# Line 110  testoutput_for_prop() Line 112  testoutput_for_prop()
112          echo testoutput_for_prop: grep "$2" $1/results/output.txt$5 1>&2          echo testoutput_for_prop: grep "$2" $1/results/output.txt$5 1>&2
113      fi      fi
114      grep "$2" $1/results/output.txt$5 | sed 's/.*=//' | cat -n > tmp2.txt      grep "$2" $1/results/output.txt$5 | sed 's/.*=//' | cat -n > tmp2.txt
115      lncnt=`wc -l tmp2.txt | awk '{print $1}' `      lncntB=`wc -l tmp2.txt | awk '{print $1}' `
116      if [ $lncnt -lt 3 ]; then      if [ $lncntB -lt 3 ]; then
117          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
118              echo Not enough lines of output when searching for "$2" 1>&2              echo Not enough lines of output when searching for "$2" 1>&2
119          fi          fi
120          return 99          return 99
121      fi      fi
122        if [ $lncntA -ne $lncntB ]; then
123            if [ $verbose -gt 0 ]; then
124                echo Not same Nb of lines when searching for "$2" ":" $lncntA $lncntB 1>&2
125            fi
126            return 99
127        fi
128        has_nan=`cat tmp1.txt | grep -i nan | wc -l`
129        if [ $has_nan -gt 0  ] ; then
130            echo testoutput_for_prop: output.txt contains $has_nan NaN values  1>&2
131            return 99
132        fi
133        has_inf=`cat tmp1.txt | grep -i inf | wc -l`
134        if [ $has_inf -gt 0  ] ; then
135            echo testoutput_for_prop: output.txt contains $has_inf Inf values  1>&2
136            return 99
137        fi
138      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
139          echo testoutput_for_prop: join tmp1.txt tmp2.txt 1>&2          echo testoutput_for_prop: join tmp1.txt tmp2.txt 1>&2
140      fi      fi
# Line 294  genmakemodel() Line 312  genmakemodel()
312              if test "x$IEEE" != x ; then              if test "x$IEEE" != x ; then
313                  command="$command -ieee"                  command="$command -ieee"
314              fi              fi
315                if test "x$MPI" = xt ; then
316                    command="$command -mpi"
317                fi
318              printf 'genmake ... ' 1>&2              printf 'genmake ... ' 1>&2
319              $command > make.log 2>&1              $command > make.log 2>&1
320              RETVAL=$?              RETVAL=$?
# Line 339  makeclean() Line 360  makeclean()
360      fi      fi
361  }  }
362    
363    postclean()
364    {
365        # postclean directory
366        if test "x$POSTCLEAN" = xt ; then
367            (
368                cd $1;
369                if test -r Makefile ; then
370                    $MAKE CLEAN >> /dev/null 2>&1
371                fi
372                exit 0
373            )
374        fi
375    }
376    
377  makedependmodel()  makedependmodel()
378  {  {
379      # makedependmodel directory      # makedependmodel directory
# Line 450  linkdata() Line 485  linkdata()
485              if test "x$ADM" = x ; then              if test "x$ADM" = x ; then
486                  files=`( cd ../input ; ls -1 | grep -v CVS )`                  files=`( cd ../input ; ls -1 | grep -v CVS )`
487                  for i in $files ; do                  for i in $files ; do
488                      if test ! -d "../input/"$i ; then                      if test ! -d "../input/"$i -a ! -f $i ; then
489                          ln -sf "../input/"$i $i                          ln -sf "../input/"$i $i
490                      fi                      fi
491                  done                  done
# Line 480  runmodel() Line 515  runmodel()
515      #  (where "$COMMAND" is relative to "directory")      #  (where "$COMMAND" is relative to "directory")
516      (      (
517          cd $1          cd $1
518          printf 'runmodel ... ' 1>&2          printf 'runmodel in %s ...' $1 1>&2
519          # make output.txt          # make output.txt
520          echo          echo
521          rm -f run.log          rm -f run.log
522            if test output.txt -ot mitgcmuv ; then
523               ( eval $COMMAND ) > run.log 2>&1
524               RETVAL=$?
525            else
526               echo ' output.txt is up to date ' > run.log 2>&1
527               RETVAL=0
528            fi
529          # echo "COMMAND='$COMMAND'"          # echo "COMMAND='$COMMAND'"
530          # echo "pwd='"`pwd`"'"          # echo "pwd='"`pwd`"'"
         ( eval $COMMAND ) > run.log 2>&1  
         RETVAL=$?  
531          if test "x$RETVAL" = x0 ; then          if test "x$RETVAL" = x0 ; then
532              tail run.log              tail run.log
533              echo successful 1>&2              echo successful 1>&2
# Line 520  createcodelet() Line 560  createcodelet()
560  int main( int argc, char** argv )  {  int main( int argc, char** argv )  {
561    int linnum,best,lncnt;    int linnum,best,lncnt;
562    double a,b,abave,relerr;    double a,b,abave,relerr;
563    best = -16;    best = -22;
564    lncnt = 0;    lncnt = 0;
565    while( 1 & (lncnt+=1) < 999 )  {    while( 1 & (lncnt+=1) < 999 )  {
566      scanf("%d", &linnum);      scanf("%d", &linnum);
# Line 529  int main( int argc, char** argv )  { Line 569  int main( int argc, char** argv )  {
569      abave = 0.5*(fabs(a)+fabs(b));      abave = 0.5*(fabs(a)+fabs(b));
570      if (abave > 0.0) {      if (abave > 0.0) {
571        relerr=fabs(a-b)/abave;        relerr=fabs(a-b)/abave;
572        if (relerr > 0.0) {        if (relerr > 0.0) { linnum = (int)rint(log10(relerr)); }
573          linnum = (int)log10(relerr);        else { linnum = -16 ; }
574          best = (best > linnum) ? best : linnum;        best = (best > linnum) ? best : linnum;
       }  
     }  
     else {  
       if (best == -16 && abave != 0)  best = -22;  
575      }      }
576    }    }
577    if (lncnt == 999) best=-29;    if (lncnt == 999) best=-29;
# Line 543  int main( int argc, char** argv )  { Line 579  int main( int argc, char** argv )  {
579    return 0;    return 0;
580  }  }
581  EOF  EOF
582      cc -o tmp_cmpnum tmp_cmpnum.c -lm      $CC -o tmp_cmpnum tmp_cmpnum.c -lm
583    
584      if [ -x ./tmp_cmpnum ]; then      if [ -x ./tmp_cmpnum ]; then
585          echo "OK"          echo "OK"
586          return 0          return 0
587      else      else
588          echo          echo
589          echo "ERROR: failed to compile comparison code"          echo "ERROR: failed to compile comparison code -- please specify"
590            echo "  a C compiler using the CC environment variable."
591          exit 1          exit 1
592      fi      fi
593  }  }
# Line 630  QUICK=f Line 667  QUICK=f
667  NOGENMAKE=f  NOGENMAKE=f
668  NOCLEAN=f  NOCLEAN=f
669  NODEPEND=f  NODEPEND=f
670    POSTCLEAN=f
671    
672  BASH=  BASH=
673  OPTFILE=NONE  OPTFILE=NONE
# Line 639  MPACKDIR="../tools/mpack-1.6" Line 677  MPACKDIR="../tools/mpack-1.6"
677  HAVE_MPACK=  HAVE_MPACK=
678  MPACK="$MPACKDIR/mpack"  MPACK="$MPACKDIR/mpack"
679  COMMAND=  COMMAND=
680  MAKE=make  if test "x$MAKE" = x ; then
681        MAKE=make
682    fi
683    if test "x$CC" = x ; then
684        CC=cc
685    fi
686  JOBS=  JOBS=
687  MPI=f  MPI=f
688    OUTDIR=
689  DELDIR=  DELDIR=
690    
691  ADM=  ADM=
# Line 698  for ac_option ; do Line 742  for ac_option ; do
742          -make=* | --make=*)          -make=* | --make=*)
743              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
744    
745            -odir | --odir)
746                ac_prev=OUTDIR ;;
747            -odir=* | --odir=*)
748                OUTDIR=$ac_optarg ;;
749    
750          -ptracers | --ptracers | -ptr | --ptr)          -ptracers | --ptracers | -ptr | --ptr)
751              ac_prev=PTRACERS_NUM ;;              ac_prev=PTRACERS_NUM ;;
752          -ptracers=* | --ptracers=* | -ptr=* | --ptr=*)          -ptracers=* | --ptracers=* | -ptr=* | --ptr=*)
# Line 707  for ac_option ; do Line 756  for ac_option ; do
756          -j=*) JOBS=$ac_optarg ;;          -j=*) JOBS=$ac_optarg ;;
757    
758          -clean | --clean)          -clean | --clean)
759              CLEANUP=t ;;              CLEANUP=t ; DELDIR=t ;;
760    
761          -quick | --quick | -q | --q)          -quick | --quick | -q | --q)
762              QUICK=t ;;              QUICK=t ;;
# Line 718  for ac_option ; do Line 767  for ac_option ; do
767          -nodepend | --nodepend | -nd | --nd)          -nodepend | --nodepend | -nd | --nd)
768              NODEPEND=t ;;              NODEPEND=t ;;
769    
770            -postclean | --postclean | -pc | --pc)
771                POSTCLEAN=t ;;
772    
773          -mpi) MPI=t ;;          -mpi) MPI=t ;;
774    
775          -adm | -ad) ADM=t ;;          -adm | -ad) ADM=t ;;
# Line 764  if test "x$ADM" = xt -a "x$COMMAND" = x Line 816  if test "x$ADM" = xt -a "x$COMMAND" = x
816  fi  fi
817    
818  if test "x$COMMAND" = x ; then  if test "x$COMMAND" = x ; then
819      COMMAND="$MAKE output.txt"      COMMAND="./mitgcmuv > output.txt"
820  fi  fi
821    
822  echo "OK"  echo "OK"
# Line 784  MACH=`hostname` Line 836  MACH=`hostname`
836  UNAMEA=`uname -a`  UNAMEA=`uname -a`
837  DATE=`date +%Y%m%d`  DATE=`date +%Y%m%d`
838  BASE="tr_"$MACH"_"$DATE"_"  BASE="tr_"$MACH"_"$DATE"_"
839    if test "x$OUTDIR" != x ; then
840        BASE="tr_"$OUTDIR"_"$DATE"_"
841    fi
842  DNUM=0  DNUM=0
843  DRESULTS="$BASE$DNUM"  DRESULTS="$BASE$DNUM"
844  while test -e $DRESULTS ; do  while test -e $DRESULTS ; do
# Line 873  for dir in $TESTDIRS ; do Line 928  for dir in $TESTDIRS ; do
928          if test -r $dir/input/Makefile ; then          if test -r $dir/input/Makefile ; then
929              ( cd $dir/input ; make CLEAN )              ( cd $dir/input ; make CLEAN )
930          fi          fi
931            (
932                cd $dir
933                rm -rf tr_run.*
934            )
935          continue          continue
936      fi      fi
937    
# Line 881  for dir in $TESTDIRS ; do Line 940  for dir in $TESTDIRS ; do
940      fout=      fout=
941      if test "x$ADM" = x ; then      if test "x$ADM" = x ; then
942          fout=$dir"/results/output.txt"          fout=$dir"/results/output.txt"
         check_for_add_mon_output  $fout  
943      else      else
944          fout=$dir"/results_ad/output.txt_adm"          fout=$dir"/results_ad/output.txt_adm"
945      fi      fi
# Line 889  for dir in $TESTDIRS ; do Line 947  for dir in $TESTDIRS ; do
947          echo "can't read \"$fout\" -- skipping $dir"          echo "can't read \"$fout\" -- skipping $dir"
948          continue          continue
949      fi      fi
950        if test "x$ADM" = x ; then
951            check_for_add_mon_output  $fout
952        fi
953    
954      # Check for additional types of monitor output      # Check for additional types of monitor output
955    
# Line 935  for dir in $TESTDIRS ; do Line 996  for dir in $TESTDIRS ; do
996      echo "Experiment:  $dir"      echo "Experiment:  $dir"
997      echo      echo
998      unset genmake makedepend make run      unset genmake makedepend make run
999      results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'      results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'
1000    
1001      #  Create an output dir for each OPTFILE/tdir combination      #  Create an output dir for each OPTFILE/tdir combination
1002      rel_CDIR=$DRESULTS"/"$dir      rel_CDIR=$DRESULTS"/"$dir
# Line 966  for dir in $TESTDIRS ; do Line 1027  for dir in $TESTDIRS ; do
1027          echo "DATE='$DATE'" >> $CDIR"/summary.txt"          echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1028          echo "tdir='$dir'" >> $CDIR"/summary.txt"          echo "tdir='$dir'" >> $CDIR"/summary.txt"
1029    
         OLD_COMMAND=$COMMAND  
         COMMAND="./mitgcmuv > output.txt"  
1030          for ex in $extra_runs ; do          for ex in $extra_runs ; do
1031              test -e "$dir/tr_run.$ex" && rm -rf "$dir/tr_run.$ex"              unset run
1032              mkdir "$dir/tr_run.$ex"              results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'
1033              links=`( cd "$dir/input" > /dev/null 2>&1 ; ls -1 | grep -v CVS )`              #  Create an output dir for each OPTFILE/tdir.ex combination
1034                rel_CDIR=$DRESULTS"/"$dir"."$ex
1035                mkdir $rel_CDIR
1036                CDIR=`pwd`"/$rel_CDIR"
1037                test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"
1038                for ldir in input.$ex input ; do
1039                    (
1040                        cd "$dir/$ldir" > /dev/null 2>&1
1041                        ls -1 2>/dev/null \
1042                            | sed -e 's|^CVS$||g' | sed -e 's|^output.txt$||g'
1043                    ) > tr_exrun_links
1044                    (
1045                        cd "$dir/tr_run.$ex"
1046                        cat ../../tr_exrun_links | while read i ; do
1047                            if test ! "x$i" = x ; then
1048                                test ! -r $i  &&  ln -s "../"$ldir"/"$i $i
1049                            fi
1050                        done
1051                    )
1052                    test -e tr_exrun_links  &&  rm -f tr_exrun_links
1053                done
1054                ldir=build
1055              (              (
1056                  cd "$dir/tr_run.$ex"                  cd $dir/tr_run.$ex
1057                  for i in $links; do                  test ! -e mitgcmuv  &&  ln -s "../"$ldir"/"mitgcmuv .
                     ln -s ../input/$i $i  
                 done  
             )  
             links=`( cd "$dir/input.$ex" > /dev/null 2>&1 ; ls -1 | grep -v CVS )`  
             (  
                 cd "$dir/tr_run.$ex"  
                 for i in $links; do  
                     test -e $i  &&  rm -f $i  
                     ln -s ../input.$ex/$i $i  
                 done  
                 ln -s ../$builddir/mitgcmuv mitgcmuv  
1058              )              )
1059              runmodel $dir/tr_run.$ex && run=Y \              runmodel $dir/tr_run.$ex && run=Y \
1060                  && results=`testoutput $dir tr_run.$ex "."$ex`                  && results=`testoutput $dir tr_run.$ex "."$ex`
# Line 998  for dir in $TESTDIRS ; do Line 1067  for dir in $TESTDIRS ; do
1067              echo "MACH='$MACH'" >> $CDIR"/summary.txt"              echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1068              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1069              echo "DATE='$DATE'" >> $CDIR"/summary.txt"              echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1070              echo "tdir='$dir'" >> $CDIR"/summary.txt"              echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"
1071          done          done
         COMMAND=$OLD_COMMAND  
1072      else      else
1073          fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`          fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`
1074          fres=$fres"$results   $dir"          fres=$fres"$results   $dir"
# Line 1012  for dir in $TESTDIRS ; do Line 1080  for dir in $TESTDIRS ; do
1080          echo "DATE='$DATE'" >> $CDIR"/summary.txt"          echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1081          echo "tdir='$dir'" >> $CDIR"/summary.txt"          echo "tdir='$dir'" >> $CDIR"/summary.txt"
1082      fi      fi
1083    
1084        postclean $dir/$builddir
1085            
1086      echo "-------------------------------------------------------------------------------"      echo "-------------------------------------------------------------------------------"
1087            
# Line 1053  fi Line 1123  fi
1123  rm -f tmp_cmpnum.c tmp_cmpnum  rm -f tmp_cmpnum.c tmp_cmpnum
1124    
1125  if test "x$CLEANUP" != xt ; then  if test "x$CLEANUP" != xt ; then
1126      cat $SUMMARY      cat $SUMMARY | sed 's/ -- -- -- --//g'
1127      if test -e tr_out.txt ; then      if test -e tr_out.txt ; then
1128          mv tr_out.txt tr_out.txt.old          mv tr_out.txt tr_out.txt.old
1129      fi      fi
1130      cat $SUMMARY > tr_out.txt      cat $SUMMARY | sed 's/ -- -- -- --//g' > tr_out.txt
1131  fi  fi
1132    
1133  if test "x$DELDIR" = xt ; then  if test "x$DELDIR" = xt ; then

Legend:
Removed from v.1.52  
changed lines
  Added in v.1.75

  ViewVC Help
Powered by ViewVC 1.1.22